---
title: EventTarget.dispatchEvent()
slug: Web/API/EventTarget/dispatchEvent
tags:
  - API
  - DOM
  - DOM Element Methods
  - Gecko
  - Method
---
<p>{{APIRef("DOM Events")}}</p>

<p><span class="seoSummary">Dispatches an {{domxref("Event")}} at the specified {{domxref("EventTarget")}}, (synchronously) invoking the affected {{domxref("EventListener")}}s in the appropriate order. The normal event processing rules (including the capturing and optional bubbling phase) also apply to events dispatched manually with <code>dispatchEvent()</code>.</span></p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><var>cancelled</var> = !<var>target</var>.dispatchEvent(<var>event</var>)
</pre>

<h3 id="Parameter">Parameter</h3>

<ul>
 <li><code><var>event</var></code> is the {{domxref("Event")}} object to be dispatched.</li>
 <li><code><var>target</var></code> is used to initialize the {{domxref("Event.target")}} and determine which event listeners to invoke.</li>
</ul>

<h3 id="Return_Value">Return Value</h3>

<ul>
 <li>The return value is <code>false</code> if <code><var>event</var></code> is cancelable and at least one of the event handlers which received <code><var>event</var></code> called {{domxref("Event.preventDefault()")}}. Otherwise it returns <code>true</code>.</li>
</ul>

<p>The <code>dispatchEvent()</code> method throws <code>UNSPECIFIED_EVENT_TYPE_ERR</code> if the event's type was not specified by initializing the event before the method was called, or if the event's type is <code>null</code> or an empty string.</p>

<h3 id="Exceptions">Exceptions</h3>

<p>Exceptions thrown by event handlers are reported as uncaught exceptions. The event handlers run on a nested callstack; they block the caller until they complete, but exceptions do not propagate to the caller.</p>

<h2 id="Notes">Notes</h2>

<p>Unlike "native" events, which are fired by the DOM and invoke event handlers asynchronously via the <a href="/en-US/docs/Web/JavaScript/EventLoop">event loop</a>, <code>dispatchEvent()</code> invokes event handlers synchronously. All applicable event handlers will execute and return before the code continues on after the call to <code>dispatchEvent()</code>.</p>

<p><code>dispatchEvent()</code> is the last step of the create-init-dispatch process, which is used for dispatching events into the implementation's event model. The event can be created using <a href="/en-US/docs/Web/API/Event/Event">Event constructor</a>.</p>

<p>See also the <a href="/en-US/docs/DOM/event" title="DOM/event">Event object reference</a>.</p>

<h2 id="Example">Example</h2>

<p>See <a href="/en-US/docs/Web/Guide/DOM/Events/Creating_and_triggering_events">Creating and triggering events</a>.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('DOM WHATWG', '#dom-eventtarget-dispatchevent', 'EventTarget.dispatchEvent()')}}</td>
   <td>{{ Spec2('DOM WHATWG') }}</td>
   <td>Initial definition in the DOM 2 Events specification.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_Compatibility">Browser compatibility</h2>

<p>{{Compat("api.EventTarget.dispatchEvent")}}</p>
